package ch.unige.solidify.test.controller.config;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.domain.EntityScan;
import org.springframework.boot.builder.SpringApplicationBuilder;
import org.springframework.boot.web.servlet.support.SpringBootServletInitializer;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.FilterType;
import org.springframework.context.annotation.PropertySource;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;
import org.springframework.security.config.annotation.method.configuration.EnableGlobalMethodSecurity;
import org.springframework.security.config.annotation.web.configuration.EnableWebSecurity;

@SpringBootApplication
@EnableWebSecurity
@EnableGlobalMethodSecurity(jsr250Enabled = true, proxyTargetClass = true, prePostEnabled = true)
@EntityScan(basePackages = "ch.unige.solidify.test.controller.dao")
@ComponentScan(basePackages = { "ch.unige.solidify.test.controller.dao",
        "ch.unige.solidify.test.controller",
        "ch.unige.solidify" }, excludeFilters = @ComponentScan.Filter(type = FilterType.REGEX, pattern = "ch\\.unige\\.solidify\\.oracle\\.test\\..*"))
@EnableJpaRepositories(basePackages = { "ch.unige.solidify.test.controller.dao" })
@PropertySource("classpath:H2_config.properties")
public class MockApplication extends SpringBootServletInitializer {
  public static void main(String[] args) {
    SpringApplication.run(MockApplication.class, args);
  }

  @Override
  protected SpringApplicationBuilder configure(SpringApplicationBuilder application) {
    return application.sources(MockApplication.class);
  }

}
